% **************************************************************************** %
% Author: Lambert Theisen
% => lambert.theisen@rwth-aachen.de
% => lambert.theisen@gmail.com
% Created: January 2019
% **************************************************************************** %



% **************************************************************************** %
% SOURCE CODE
% **************************************************************************** %

  % -------------------------------------------------------------------------- %
  % LISTINGS
  % -------------------------------------------------------------------------- %
  % - LOL:
  %   $ \lstlistoflistings\
  % - Centered listings:
  %   https://tex.stackexchange.com/questions/5818/how-to-center-a-listing
  % - Usage:
  %   \lstinputlisting[
  %     % style=cppTwoCol,
  %     style=graycolor,
  %     language=Python,
  %     label={list_app_adaptive},
  %     caption={\file{3d-stirrer-adaptive.geo}}
  %   ]{listings/solver.py}
  % -------------------------------------------------------------------------- %

    % ------------------------------------------------------------------------ %
    % Main settings
    % ------------------------------------------------------------------------ %
      % \usepackage{listingsutf8}
      \usepackage{listings}
      % LOL Name:
      \renewcommand*{\lstlistlistingname}{List of Listings}
    % ------------------------------------------------------------------------ %

    % ------------------------------------------------------------------------ %
    % Code styles
    % ------------------------------------------------------------------------ %

      % ---------------------------------------------------------------------- %
      % Own Bachelor Thesis Style
      % ---------------------------------------------------------------------- %
        \definecolor{codeBackgroundColor}{rgb}{0.97,0.97,0.97}
        \usepackage{multicol} % for multi column listings
        \setlength\columnsep{15pt}
        \lstdefinestyle{cpp}{
          backgroundcolor=\color{codeBackgroundColor},
          language=C++,
          numbers=left,
          breaklines=true,
          breakindent=5pt,
          tabsize=2,
          numbersep=2pt,
          captionpos=b,
          basicstyle=\ttfamily\scriptsize, % ttfamily for Courier
          boxpos=c, %TODO: Centered?!
          % caption=\lstname,
          % linewidth=.5\textwidth,
          % xleftmargin=.2\textwidth,
          % xrightmargin=.2\textwidth,
          % xleftmargin=10pt,
          % xrightmargin=15pt,
        }
        \lstdefinestyle{cppTwoCol}{
          style=cpp,
          multicols=2,
        }
        \lstdefinestyle{cppOneCol}{
          style=cpp,
        }
      % ---------------------------------------------------------------------- %

      % ---------------------------------------------------------------------- %
      % Fenics Book Style
      % https://bitbucket.org/fenics-project/fenics-book/src/master/packages/
      %   codehighlight.sty
      % ---------------------------------------------------------------------- %
        \definecolor{background_c}{rgb}{.95,.95,.95}
        \colorlet{comment_c}{green!50!black}
        \colorlet{string_c}{red!60!black}
        \colorlet{keyword_c}{magenta!90!black}
        \colorlet{identifier_c}{black!90!white}
        \colorlet{emph_c}{blue!70!white}
        \colorlet{specialfunctions_c}{blue!60!green}
        \lstdefinestyle{pythonstyle}{
          %
          language=Python,
          %
          numbers=left,
          numbersep=2mm,
          numberstyle=\tiny\color{gray},
          captionpos=b,
          %
          backgroundcolor=\color{yellow!10},
          basicstyle=\footnotesize \ttfamily,
          %
          % Docstring as comments
          deletestring=[s]{r"""}{"""},
          morecomment=[s]{r"""}{"""},
          morecomment=[s]{"""}{"""},
          %
          otherkeywords={\ , \}, \{, \%, \&, \|},
          keywordstyle=\color{keyword_c}\bfseries,
          commentstyle=\color{comment_c}\itshape,
          stringstyle=\color{string_c},
          identifierstyle=\color{identifier_c},
          emphstyle=\color{blue}\bfseries,
          %
          emph={[2]True, False, None},
          emphstyle=[2]\color{keyword_c},
          %
          emph={[4]ode, fsolve, sqrt, exp, sin, cos, arccos, pi,  array, norm, solve, dot, arange, , isscalar, max, sum, flatten, shape, reshape, find, any, all, abs, plot, linspace, legend, quad, polyval,polyfit, hstack, concatenate,vstack,column_stack,empty,zeros,ones,rand,vander,grid,pcolor,eig,eigs,eigvals,svd,qr,tan,det,logspace,roll,min,mean,cumsum,cumprod,diff,vectorize,lstsq,cla,eye,xlabel,ylabel,squeeze},
          emphstyle=[4]\color{specialfunctions_c},
          emph={[10]jump, grad, tr, transpose, Identity, div, dx, ds, dS, inner, dot, as_tensor, indices, Measure, CellDiameter},
          emphstyle=[10]\color{specialfunctions_c},
          %
          breaklines=false,
          breakatwhitespace=true,
          breakindent=40pt,
          keepspaces=true,
          columns=fullflexible, % tighter character kerning, like verb
          showtabs=false,
          tab=, % dont print tab replacement
          tabsize=4,
          showstringspaces=false,
          showspaces=false,
          escapeinside={(*@}{@*)}, % Render Latex in between
          extendedchars=\true, % allows non-ascii chars, does not work with utf-8
          %
          xleftmargin=2mm,
          xrightmargin=0mm,
          framexleftmargin=0mm,
          frame=single,
          % framerule=1pt, % 1pt is thicker as default
          %
          % aboveskip=2ex, % vertical space above code frame
          % belowskip=\smallskipamount, % space between code and text below
        }
        \lstdefinestyle{cppstyle}{
          %
          language=c++,
          %
          numbers=left,
          numbersep=2mm,
          numberstyle=\tiny\color{gray},
          captionpos=b,
          %
          backgroundcolor=\color{yellow!10},
          basicstyle=\footnotesize \ttfamily,
          %
          %
          keywordstyle=\color{keyword_c}\bfseries,
          commentstyle=\color{comment_c}\itshape,
          stringstyle=\color{string_c},
          identifierstyle=\color{identifier_c},
          emphstyle=\color{blue}\bfseries,
          %
          breaklines=true,
          breakatwhitespace=true,
          breakindent=40pt,
          keepspaces=true,
          columns=fullflexible, % tighter character kerning, like verb
          showtabs=false,
          tab=, % dont print tab replacement
          tabsize=4,
          showstringspaces=false,
          showspaces=false,
          escapeinside={(*@}{@*)}, % Render Latex in between
          extendedchars=\true, % allows non-ascii chars, does not work with utf-8
          %
          xleftmargin=2mm,
          xrightmargin=0mm,
          framexleftmargin=0mm,
          frame=single,
          % framerule=1pt, % 1pt is thicker as default
          %
          % aboveskip=2ex, % vertical space above code frame
          % belowskip=\smallskipamount, % space between code and text below
        }
        \newcommand\YAMLcolonstyle{\tiny \ttfamily}
        \newcommand\YAMLkeystyle{\tiny \ttfamily}
        \newcommand\YAMLvaluestyle{\color{keyword_c} \tiny \ttfamily}
        \lstdefinestyle{ymlstylesmall}{
          %
          numbers=left,
          numbersep=2mm,
          numberstyle=\tiny\color{gray},
          captionpos=b,
          %
          backgroundcolor=\color{yellow!10},
          basicstyle=\YAMLkeystyle,
          %
          keywords={true,True,false,False,null,y,n},
          comment=[l]{\#},
          morecomment=[s]{/*}{*/},
          moredelim=[l][\color{orange}]{\&},
          moredelim=[l][\color{magenta}]{*},
          moredelim=**[il][\YAMLcolonstyle{:}\YAMLvaluestyle]{:},   % switch to value style at :
          morestring=[b]',
          morestring=[b]",
          %
          keywordstyle=\color{keyword_c}\bfseries,
          commentstyle=\color{comment_c}\itshape,
          stringstyle=\color{string_c},
          identifierstyle=\color{identifier_c},
          emphstyle=\color{blue}\bfseries,
          %
          breaklines=true,
          breakatwhitespace=true,
          breakindent=40pt,
          keepspaces=true,
          columns=fullflexible, % tighter character kerning, like verb
          showtabs=false,
          tab=, % dont print tab replacement
          tabsize=4,
          showstringspaces=false,
          showspaces=false,
          escapeinside={(*@}{@*)}, % Render Latex in between
          extendedchars=\true, % allows non-ascii chars, does not work with utf-8
          %
          xleftmargin=2mm,
          xrightmargin=0mm,
          framexleftmargin=0mm,
          frame=single,
          % framerule=1pt, % 1pt is thicker as default
          %
          % aboveskip=2ex, % vertical space above code frame
          % belowskip=\smallskipamount, % space between code and text below
        }
      % ---------------------------------------------------------------------- %

    % ------------------------------------------------------------------------ %

  % -------------------------------------------------------------------------- %


  % -------------------------------------------------------------------------- %
  % PYGMENTS
  % -------------------------------------------------------------------------- %
  % - Requirements:
  %   $ pip install Pygments
  % - LOL:
  %   $ \listoflistings\
  % - TODO Usage:
  % % minted
  % % ------
  % \begin{listing}[!ht]
  %   % \inputminted{python}{listings/solver.py}
  %   \pythoncode{listings/solver.py}
  %   \caption{Example of a listing.}
  %   \label{lst:example}
  % \end{listing}
  % %
  % % minted pagebreak
  % % ----------------
  % \begin{sourcecode}
  %   \pythoncode{listings/solver.py}
  %   \caption{My Func}\label{lst:my_func}
  % \end{sourcecode}
  % -------------------------------------------------------------------------- %

    % \usepackage{caption}
    % \usepackage[
    %   chapter, % use chapter-based counting
    %   newfloat,
    % ]{minted}

    % \definecolor{bg_bright}{rgb}{0.95,0.95,0.95}
    % \definecolor{bg_dark}{rgb}{0.05,0.05,0.05}
    % \newmintedfile[pythoncode]{bash}{
    %   bgcolor=bg_bright,
    %   frame=single,
    %   % frame=lines,
    %   fontsize=\footnotesize,
    %   % style=perldoc,
    %   % style=colorful,
    %   % style=monokai,
    % }
    % \newenvironment{sourcecode}{\captionsetup{type=listing}}{}

  % -------------------------------------------------------------------------- %

% **************************************************************************** %



% **************************************************************************** %
% SOURCE CODE DOCU (INCLUDE PDFs)
% Use with: \includepdf[frame, scale=0.9, pages=-,pagecommand=\thispagestyle{scrheadings}]{listings/solver_documentation/fenicsR13.pdf}
% **************************************************************************** %
  \usepackage{pdfpages}
% **************************************************************************** %
